#!/bin/csh
# usage : dit_tbl* directory {d.tbl i.tbl t.tbl}
#
set dit_tbl=`basename $0`
#
if ($#argv != 1 && $#argv != 4) then
  stderr usage : $dit_tbl directory \{d.tbl i.tbl t.tbl\} ; exit 1
endif
#
set dir=$argv[1]
if (!(-d $dir)) then
  stderr $dir : directory not found. ; exit 1
endif
#
set log=${dir}/output.log
if (!(-e $log)) then
  stderr $log : log file not found. ; exit 1
endif
#
set dark=${dir}/d.img
if (!(-e $dark)) then
  set dark=${dir}/dark.img
  if (!(-e $dark)) then
    stderr $dark : dark-image file not found. ; exit 1
  endif
endif
#
if ($#argv == 4) then
  foreach tbl ($argv[2-4])
    if (-e $tbl) then
      stderr $tbl : file already exists. ; exit 1
    endif
  end
#
  set awk1=('$1==0 { printf "%s\t%s\n",$3,$4 >"'${argv[2]}'" }' \
            '$1==2 { printf "%s\t%s\n",$3,$4 >"'${argv[3]}'" }' \
            '$1==4 { printf "%s\t%s\n",$3,$4 >"'${argv[4]}'" }')
  alias CUT 'awk "$awk1"'
else
  alias CUT 'cut -f3-4'
endif
#
set awk0=('BEGIN { S=F[0]=F[1]=I[0]=I[1]=0 }' \
          'S==0 && NF==0 { S=1 }' \
          'S==0 && NF==1 { Zf[$1+0]=$1 }' \
          'S==0 && NF==4 { if ((z=Zf[$1+0])=="") ++F[$4]; else' \
                        '{ i=I[$4]++; Zi[$4,i]=z; T[$4,i]=$2; A[$4,i]=$3 }}' \
          'END { if (F[0]!=0 || F[1]!=0 || I[0]==0 || I[1]==0)' \
                  'print "'${dir}'/q[0-9]*[0-9].img :' \
                         'I0- and/or I-image file(s) not found." |' \
                        '"cat 1>&2";' \
                'else {' \
                  'printf "0\t0\t'${dark}'\t0\n";' \
                  'for (i0i=0; i0i<2; i0i++) {' \
                    'printf "%d\t0\n",i0i*2+1;' \
                    'for (i=0; i<I[i0i]; i++)' \
                      'printf "%d\t%s\t'${dir}'/q%s.img\t%s\n",' \
                             'i0i*2+2,A[i0i,i],Zi[i0i,i],T[i0i,i] }}}')
( ls $dir | grep '^q[0-9]*[0-9].img$' | sed -e s/\^q//g -e s/.img\$//g ; \
  cat $log | tr -d \\r ) | awk "$awk0" | sort -n | CUT
