
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "srf.h"

extern void	Error();

typedef	struct List {
		int		n;
		double		t;
		struct List	*next;
	} List;

static double	Abs(d)
double		d;
{
	return (d<0.0)?-d:d;
}

static int	Nearest(list,t)
List		*list;
double		t;
{
	double	d,D=Abs(list->t-t);
	int	n=list->n;

	while ((list=list->next)!=NULL)
	    if ((d=Abs(list->t-t))<D) {
		D=d; n=list->n;
	    }

	return n;
}

#define STR_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	*O,*D,**Q,path[STR_LEN],line[STR_LEN],
		A[STR_LEN],A1[STR_LEN],A2[STR_LEN],*I1,*I2,hp2DO[STR_LEN*6];
	int	N,n,i_e,e1=(-1),e2=(-1);
	FILE	*file;
	double	t,a,t1,t2,a1=180.0,a2=0.0;
	List	*list=NULL,**ptr=(&list);

	if (argc!=2 && argc!=4) Error("usage : DO_tbl directory {z1 z2}");

	SearchRawFiles(argv[1],&O,&D,&N,&Q);

	(void)sprintf(path,"%s/%s",argv[1],O);
	if ((file=fopen(path,"r"))==NULL) {
	    (void)fputs(path,stderr); Error(" : file not found.");
	}
	while (fgets(line,STR_LEN,file)!=NULL)
	    if (sscanf(line,"%d %lf %s %d",&n,&t,A,&i_e)==4 &&
		n>=0 && n<N && i_e>=0 && i_e<=1 && Q[n]!=NULL)
		if (i_e==0) {
		    if ((*ptr=(List *)malloc(sizeof(List)))==NULL)
			Error("no memory for log data list.");

		    (*ptr)->n=n; (*ptr)->t=t; ptr=(&((*ptr)->next));
		}
		else if (sscanf(A,"%lf",&a)==1) {
		    if (e1==(-1) || a<a1) {
			e1=n; t1=t; a1=a; (void)strcpy(A1,A);
		    }
		    if (e2==(-1) || a>a2) {
			e2=n; t2=t; a2=a; (void)strcpy(A2,A);
		    }
		}

	if (list==NULL || e1==e2) Error("no I0- and/or I-image file.");

	(void)fclose(file);

	*ptr=NULL; I1=Q[Nearest(list,t1)];
		   I2=Q[Nearest(list,t2)];

	(void)fprintf(stderr,"D000 = %s/%s\n"
			     "I000 = %s/%s\n"
			     "T000 = %s/%s at angle = %s\n"
			     "D180 = %s/%s\n"
			     "I180 = %s/%s\n"
			     "T180 = %s/%s at angle = %s\n",
			     argv[1],D,argv[1],I1,argv[1],Q[e1],A1,
			     argv[1],D,argv[1],I2,argv[1],Q[e2],A2);

	(void)sprintf(hp2DO,"hp2DO %s/%s %s/%s %s/%s %s/%s %s/%s %s/%s",
			    argv[1],D,argv[1],I1,argv[1],Q[e1],
			    argv[1],D,argv[1],I2,argv[1],Q[e2]);

	if (argc==4)
	    for (n=2; n<4; n++) (void)strcat(strcat(hp2DO," "),argv[n]);

	return system(hp2DO);
}
