
#include <stdio.h>
#include <stdlib.h>

#define L	1024

int	main(c,v)
int	c;
char	**v;
{
	int	Z,z,x,y,X,Y;
	char	*p,l[L];
	FILE	*f;
	size_t	N,n;
	double	*d,*a,m;

#define ERROR(s)	(void)fputs(s "\n",stderr); exit(1)
#define ABORT(s)	(void)fprintf(stderr,"%s : " s "\n",p); exit(1)

	if (c<4 || c%2!=0) {
	ERROR("usage : ama array1 multiplier1 {array2 multiplier2 ...} array");
	}
	Z=c/2-1;
	for (z=0; z<Z; z++) {
	    p=v[z*2+1];
	    if ((f=fopen(p,"rb"))==NULL) { ABORT("file not found."); }

	    if (fgets(l,L,f)==NULL ||
		sscanf(l,"%d %d",&x,&y)!=2 ||
	       (z==0 && (x<=0 || y<=0)) ||
	       (z!=0 && (x!=X || y!=Y))) { ABORT("bad array size."); }

	    if (z==0) {
		N=(size_t)(X=x)*(size_t)(Y=y);
		if ((d=(double *)malloc(sizeof(double)*N*2))==NULL) {
		    ERROR("memory allocation error.");
		}
		a=d+N;
		for (n=0; n<N; n++) a[n]=0.0;
	    }
	    if (fread(d,sizeof(double),N,f)!=N) { ABORT("data read error."); }

	    (void)fclose(f);

	    p=v[z*2+2];
	    if (sscanf(p,"%lf",&m)!=1) { ABORT("bad multiplier."); }

	    for (n=0; n<N; n++) a[n]+=(d[n]*m);
	}
	p=v[c-1];
	if (p[0]=='-')
	    f=stdout;
	else
	    if ((f=fopen(p,"wb"))==NULL) { ABORT("file not stored."); }

	if (fprintf(f,"%d\t%d\n",X,Y)<0 ||
	    fwrite(a,sizeof(double),N,f)!=N) { ABORT("data write error."); }

	if (f!=stdout) (void)fclose(f); free(d); return 0;
}
