
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define time	tick	/* to prevent error of lint */

static void	Error(head,tail)
char		*head,*tail;
{
	if (*head!='\0') (void)fprintf(stderr,"%s : ",head);

	(void)fputs(tail,stderr); (void)fputc('\n',stderr); exit(1);
}

#define ALLOC(type,noe)	(type *)malloc(sizeof(type)*(size_t)(noe))

typedef unsigned short	Word;
typedef struct {
		union {
			struct {
				char	*path;
				long	offset;
			} f;
			Word	*memory;
		} u;
		double	time;
	} Table;
typedef struct {
#ifdef	OM
		union {
			struct {
				char	*path;
				long	offset;
			} f;
			Word	*memory;
		} u;
#else
		char	*path;
		long	offset;
#endif
		double	time,Rd1,Rd2,Ri1,Ri2;
		Word	*Md1,*Md2,*Mi1,*Mi2;
	} TableT;

static int	Fgetw(file)
FILE		*file;
{
	int	lo,hi;

	return ((lo=fgetc(file))==EOF || (hi=fgetc(file))==EOF)?-1:hi*256+lo;
}

static char	*fnf="file not found.";
static int	Nh,Nv,first=1;
static double	time1,time2;

#define STR_LEN	1024

static void	Check(tPath,Nt,di,T)
char		*tPath;
int		*Nt,di;
Table		**T;
{
	FILE	*tFile,*file;
	char	line[STR_LEN],path[STR_LEN],
		*tmae="table memory allocation error.";
	double	time;

	struct List {
			char		*path;
			long		offset;
			double		time;
			struct List	*next;
		} *l,*next,**L=(&next);

	if (*tPath=='-')
	    tFile=stdin;
	else
	    if ((tFile=fopen(tPath,"r"))==NULL) Error(tPath,fnf);

	for (*Nt=0; fgets(line,STR_LEN,tFile)!=NULL &&
		    sscanf(line,"%s %lf",path,&time)==2; (*Nt)++) {
	    if ((*L=l=ALLOC(struct List,1))==NULL ||
		(l->path=strdup(path))==NULL)
		Error(path,"list memory allocation error.");

	    if ((file=fopen(path,"rb"))==NULL) Error(path,fnf);

	    if (fgetc(file)!='I' ||
		fgetc(file)!='M' ||
		(l->offset=Fgetw(file)+64)<64) Error(path,"bad image header.");

	    if (first) {
		if ((Nh=Fgetw(file))<0 ||
		    (Nv=Fgetw(file))<0) Error(path,"bad image size.");

		time1=time2=time; first=0;
	    }
	    else {
		if (Fgetw(file)!=Nh ||
		    Fgetw(file)!=Nv) Error(path,"image size not match.");

		if (time<time1) time1=time; else if (time>time2) time2=time;
	    }
	    l->time=time;

	    if (fseek(file,4L,SEEK_CUR) ||
		Fgetw(file)!=2) Error(path,"bad image type.");

	    L=(&(l->next)); (void)fclose(file);
	}
	if (tFile!=stdin) (void)fclose(tFile);

	if (*Nt==0) Error(tPath,"empty table.");

	if (di)
{
	Table	*t=ALLOC(Table,(*Nt==1)?2:*Nt);

	if ((*T=t)==NULL) Error(tPath,tmae);

	for (*L=NULL; (l=next)!=NULL; t++) {
	    t->u.f.path=l->path;
	    t->u.f.offset=l->offset; t->time=l->time; next=l->next; free(l);
	}
}
	else
{
	TableT	*tt=ALLOC(TableT,*Nt);

	if ((*T=(Table *)tt)==NULL) Error(tPath,tmae);

	for (*L=NULL; (l=next)!=NULL; tt++) {
#ifdef	OM
	    tt->u.f.path=l->path; tt->u.f.offset=l->offset;
#else
	    tt->path=l->path; tt->offset=l->offset;
#endif
	    tt->time=l->time; next=l->next; free(l);
	}
}}

static int	h1,h2,N;
static long	O;

#define SOW	sizeof(Word)

static void	Read(path,offset,v1,v2,memory)
char		*path;
long		offset;
int		v1,v2;
Word		*memory;
{
	FILE	*file;
	short	s=127;
	char	*ptr,tmp,*c=(char *)&s,*idre="image data read error.";
	int	v,h;

	if ((file=fopen(path,"rb"))==NULL) Error(path,fnf);

	if (*c!=127)
	    for (offset+=(v1*O+h1*SOW), v=v1; v<=v2; v++, offset+=O) {
		if (fseek(file,offset,SEEK_SET) ||
		    fread(memory,SOW,(size_t)N,file)!=N) Error(path,idre);

		for (h=h1; h<=h2; h++, memory++) {
		    ptr=(char *)memory; tmp=ptr[0]; ptr[0]=ptr[1]; ptr[1]=tmp;
		}
	    }
	else
	    for (offset+=(v1*O+h1*SOW), v=v1; v<=v2; v++, offset+=O, memory+=N)
		if (fseek(file,offset,SEEK_SET) ||
		    fread(memory,SOW,(size_t)N,file)!=N) Error(path,idre);

	(void)fclose(file);
}

static int	Compare(t1,t2)
Table		*t1,*t2;
{
	return (t1->time>t2->time)?1:(t1->time<t2->time)?-1:0;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nd,Ni,Nt,v1,v2,n,v,h;
	Table	*Td,*Ti,*t;
	TableT	*Tt,*tt;
	size_t	M;
	Word	*memory,*m;
	char	path[STR_LEN],format[STR_LEN],header[STR_LEN],
		*imae="image memory allocation error.";
	double	*P,*p,D,I,T;
	FILE	*file;

	if (argc!=2 && argc!=4 && argc!=5 && argc!=6 && argc!=7 && argc!=9)
	Error("usage","hp2sg {d.tbl i.tbl t.tbl} {v1 v2}|{h1 v1 h2 v2} SG/");

	if (argc==2 || argc==4 || argc==6) {
	    Check("-",&Nd,1,&Td);
	    Check("-",&Ni,1,&Ti);
	    Check("-",&Nt,0,(Table **)&Tt);
	}
	else {
	    Check(argv[1],&Nd,1,&Td);
	    Check(argv[2],&Ni,1,&Ti);
	    Check(argv[3],&Nt,0,(Table **)&Tt);
	}
	switch(argc) {
	    case 2 : case 5 :
		h1=v1=0; h2=Nh-1; v2=Nv-1; break;
	    case 4 : case 7 :
		h1=0; h2=Nh-1; v1=atoi(argv[argc-3]);
			       v2=atoi(argv[argc-2]); break;
	    case 6 : case 9 :
		h1=atoi(argv[argc-5]); v1=atoi(argv[argc-4]);
		h2=atoi(argv[argc-3]); v2=atoi(argv[argc-2]); break;
	}
	if (h1<0 || h2>=Nh || h1>h2 ||
	    v1<0 || v2>=Nv || v1>v2) Error("","bad image area.");

	N=h2-h1+1; O=Nh*SOW; M=(size_t)(v2-v1+1)*(size_t)N;

	for (t=Td, n=0; n<Nd; n++, t++) {
	    if ((memory=ALLOC(Word,M))==NULL) Error(t->u.f.path,imae);

	    Read(t->u.f.path,t->u.f.offset,v1,v2,memory);
	    free(t->u.f.path); t->u.memory=memory;
	}
	if (Nd==1) {
	    Td->time=time1; t->u.memory=memory; t->time=time2; Nd=2;
	}
	else
	    qsort(Td,(size_t)Nd,sizeof(Table),Compare);

	for (t=Ti, n=0; n<Ni; n++, t++) {
	    if ((memory=ALLOC(Word,M))==NULL) Error(t->u.f.path,imae);

	    Read(t->u.f.path,t->u.f.offset,v1,v2,memory);
	    free(t->u.f.path); t->u.memory=memory;
	}
	if (Ni==1) {
	    Ti->time=time1; t->u.memory=memory; t->time=time2; Ni=2;
	}
	else
	    qsort(Ti,(size_t)Ni,sizeof(Table),Compare);

	for (tt=Tt, n=0; n<Nt; n++, tt++) {
#ifdef	OM
	    if ((memory=ALLOC(Word,M))==NULL) Error(tt->u.f.path,imae);

	    Read(tt->u.f.path,tt->u.f.offset,v1,v2,memory);
	    free(tt->u.f.path); tt->u.memory=memory;
#endif
	    for (t=Td+Nd-2; t!=Td && t->time>tt->time; t--) ;

	    tt->Md1=t->u.memory; tt->Md2=t[1].u.memory;
	    tt->Rd1=1.0-(tt->Rd2=(tt->time-t->time)/(t[1].time-t->time));

	    for (t=Ti+Ni-2; t!=Ti && t->time>tt->time; t--) ;

	    tt->Mi1=t->u.memory; tt->Mi2=t[1].u.memory;
	    tt->Ri1=1.0-(tt->Ri2=(tt->time-t->time)/(t[1].time-t->time));
	}
#ifndef	OM
	if ((memory=ALLOC(Word,N))==NULL) Error("",imae);
#endif
	if ((P=ALLOC(double,N))==NULL)
	    Error("","projection memory allocation error.");

	(void)sprintf(path,"%d",Nv-1);
	(void)sprintf(format,"%s/%%0%ud",argv[argc-1],(unsigned)strlen(path));
	(void)sprintf(header,"%d\t%d\n",N,Nt);
#ifdef	OM
	for (M=0, v=v1; v<=v2; v++, M+=N) {
#else
	for (v=v1; v<=v2; v++) {
#endif
	    (void)sprintf(path,format,v);
	    if ((file=fopen(path,"wb"))==NULL ||
		fputs(header,file)==EOF) Error(path,"file not stored.");

	    for (tt=Tt, n=0; n<Nt; n++, tt++) {
#ifdef	OM
		memory=tt->u.memory+M;
#else
		Read(tt->path,tt->offset,v,v,memory);
#endif
		for (m=memory, p=P, h=0; h<N; h++) {
		    D=tt->Rd1*(double)*(tt->Md1++)+tt->Rd2*(double)*(tt->Md2++);
		    I=tt->Ri1*(double)*(tt->Mi1++)+tt->Ri2*(double)*(tt->Mi2++);
		    T=(double)*(m++);
		    *(p++)=(I>D && T>D)?log((I-D)/(T-D)):0.0;
		}
		if (fwrite(P,sizeof(double),(size_t)N,file)!=N)
		    Error(path,"projection data write error.");
	    }
	    (void)fclose(file);
	}
	free(P);
#ifdef	OM
	for (n=Nt-1; n>=0; n--) free(Tt[n].u.memory);
#else
	free(memory); for (n=Nt-1; n>=0; n--) free(Tt[n].path);
#endif
	for (n=(Ni==2 && Ti[1].u.memory==Ti->u.memory)?0:Ni-1; n>=0; n--)
	    free(Ti[n].u.memory);

	for (n=(Nd==2 && Td[1].u.memory==Td->u.memory)?0:Nd-1; n>=0; n--)
	    free(Td[n].u.memory);

	free(Tt); free(Ti); free(Td); return 0;
}
