
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"
#ifdef	__unix__
#include <unistd.h>
#endif

extern void	Error();

#define STR_LEN	1024

static int	N;
static Cell	**mask;
static double	N1,xy0;
#ifdef	__unix__
static long	A=(-1);
static char	last[STR_LEN];
#endif

static void	MaskForTomoGram(r0_dr,path)
char		*r0_dr,*path;
{
	double	R,y,x,C=(-atof(r0_dr)),c=N1-C;
	int	v,h;
#ifdef	__unix__
	long	a=0;
	int	i;
#endif

	if (C<=0.0 || c<=0.0) {
(void)fprintf(stderr,"%s for %s : bad detector offset (warning).\n",r0_dr,path);

	    for (v=0; v<N; v++)
	    for (h=0; h<N; h++) mask[v][h]=0;
	}
	else {
	    R=(C<c)?C:c;
	    for (y=xy0, v=0; v<N; v++, y+=1.0)
	    for (x=xy0, h=0; h<N; h++, x+=1.0)
#ifdef	__unix__
		a+=(
#endif
		mask[v][h]=R*R>x*x+y*y
#ifdef	__unix__
		)
#endif
		;
	}
#ifdef	__unix__
	if (a!=A || link(last,path)) {
#endif
	    StoreImageFile(path,N,N,1,mask,NULL);
#ifdef	__unix__
	    A=a; for (i=0; (last[i]=path[i])!='\0'; i++) ;
	}
#endif
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	n;
	char	r0_dr[STR_LEN],path[STR_LEN];

	if (argc!=2 && argc!=4) Error("usage : mask4tg N {r0/dr TIFF}");

	if ((N=atoi(argv[1]))<=0) Error("bad detector number.");

	if ((mask=(Cell **)malloc(sizeof(Cell *)*(size_t)N))==NULL ||
	    (*mask=(Cell *)malloc(sizeof(Cell)*(size_t)N*(size_t)N))==NULL)
	    Error("memory allocation error.");

	for (n=1; n<N; n++) mask[n]=mask[n-1]+N;

	N1=(double)(N-1); xy0=(-N1/2.0);
	if (argc==2)
	    while (scanf("%s %s",r0_dr,path)==2) MaskForTomoGram(r0_dr,path);
	else
	    MaskForTomoGram(argv[2],argv[3]);

	return 0;
}
