
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "sif.h"

extern void	Error();

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	char	str[LEN];
	int	N,M,bps,m,n;
	Cell	**cell,c;
	double	dt,p,t,t0=0.0,tl=1.0,dr=1.0;

	if (argc!=4 && argc!=5 && argc!=6 && argc!=7)
	    Error("usage : sg_p2t SG_XP_array {dr} {t0 dt} BPS SG_XT_TIFF");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL)
		Error("sinogram file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad number of sinogram data.");

	if ((cell=(Cell **)malloc(sizeof(Cell *)*(size_t)M))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*(size_t)M*(size_t)N))==NULL)
	    Error("memory allocation error.");

	if ((bps=atoi(argv[argc-2]))<=0 || bps>8*sizeof(Cell))
	    Error("bad sinogram image BPS.");

	c=(Cell)((1<<bps)-1);

	if (argc==4 || argc==5)
	    dt=1.0/(double)c;
	else {
	    if ((dt=atof(argv[argc-3]))<=0) Error("bad value step.");

	    t0=atof(argv[argc-4]); tl=t0+dt*(double)c;
	}
	if (argc==5 || argc==7)
	    if ((dr=atof(argv[2]))<=0.0) Error("bad detector interval.");

	for (m=0; m<M; m++) {
	    if (m!=0) cell[m]=cell[m-1]+N;

	    for (n=0; n<N; n++) {
		if (fread(&p,sizeof(double),(size_t)1,file)!=1)
		    Error("sinogram data read error.");

		cell[m][n]=((t=exp(-p*dr))<t0)?0:(t>tl)?c:(Cell)((t-t0)/dt+0.5);
	    }
	}
	if (file!=stdin) (void)fclose(file);

	StoreImageFile(argv[argc-1],N,M,bps,cell,NULL); return 0;
}
