
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include "srf.h"

static void	Abort(d_name,f_name,msg)
char		*d_name,*f_name,*msg;
{
	(void)fprintf(stderr,"%s/%s : %s\n",d_name,f_name,msg); exit(1);
}

static int	StrCmp(s1,s2)
char		*s1,*s2;
{
	int	c1,c2;

	do
	    if ((c1=(*s1>='a' && *s1<='z')?*s1-32:*s1)!=
		(c2=(*s2>='a' && *s2<='z')?*s2-32:*s2)) break;
	while (*(s1++)!='\0' && *(s2++)!='\0');

	return c1-c2;
}

#define STR_LEN	1024

void	SearchRawFiles(directory,output_log,dark_img,q_range,q_img)
char	*directory,**output_log,**dark_img,***q_img;
int	*q_range;
{
	DIR		*dir;
	struct dirent	*ent;
	int		l,r,O=0,D=0,Dark=0,R=0;
	char		o[STR_LEN],d[STR_LEN],dark[STR_LEN],**I,
			*df="duplicated file.",
			*nmfrf="no memory for raw file(s).";

#define ABORT(f_n,msg)	Abort(directory,f_n,msg)

	if ((dir=opendir(directory))==NULL) ABORT("","directory not open.");

#define	F_N	ent->d_name

	while ((ent=readdir(dir))!=NULL)
	    if (!StrCmp(F_N,"output.log"))
		if (++O==1) (void)strcpy(o,F_N); else ABORT(F_N,df);
	    else if (!StrCmp(F_N,"d.img"))
		if (++D==1) (void)strcpy(d,F_N); else ABORT(F_N,df);
	    else if (!StrCmp(F_N,"dark.img"))
		if (++Dark==1) (void)strcpy(dark,F_N); else ABORT(F_N,df);
	    else if ((F_N[0]=='q' || F_N[0]=='Q') &&
		     (l=strlen(F_N))>5 && !StrCmp(F_N+l-4,".img") &&
		     (r=atoi(F_N+1))>=R) R=r+1;

	if (!O) ABORT("output.log","log file not found.");
	if (!D && !Dark) ABORT("dark.img","dark-image file not found.");
	if (!R) ABORT("q[0-9]*[0-9].img","I0- and/or I-image file not found.");

	if ((*output_log=strdup(o))==NULL ||
	    (*dark_img=strdup(D?d:dark))==NULL ||
	    (I=(char **)malloc((size_t)R*sizeof(*I)))==NULL) ABORT("",nmfrf);

	for (r=0; r<R; r++) I[r]=NULL;

	rewinddir(dir);

	while ((ent=readdir(dir))!=NULL)
	    if ((F_N[0]=='q' || F_N[0]=='Q') &&
		(l=strlen(F_N))>5 && !StrCmp(F_N+l-4,".img") &&
		(r=atoi(F_N+1))>=0) {
		if (r>=R) ABORT(F_N,"bad sequence number.");
		if (I[r]!=NULL) ABORT(F_N,"duplicated sequence number.");
		if ((I[r]=strdup(F_N))==NULL) ABORT(F_N,nmfrf);
	    }

	(void)closedir(dir);

	*q_range=R; *q_img=I;
}
