
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "srf.h"

extern void	Error();

static double	Abs(d)
double		d;
{
	return (d<0.0)?-d:d;
}

#define STR_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	*xy_tif,xy[4],*O,*D,**Q,path[STR_LEN],line[STR_LEN],
		A[STR_LEN],Ae[STR_LEN],hp3xy[STR_LEN*6];
	int	N,n,i_e,i,e=(-1);
	FILE	*file;
	double	angle,t,a,dat,te,Dat=0.0;

#define List	struct LIST

	List {
		int	n;
		double	t;
		List	*next;
	} *list,*top=NULL,**ptr=(&top);

	if ((xy_tif=strrchr(argv[0],'\\'))!=NULL ||
	    (xy_tif=strrchr(argv[0],'/' ))!=NULL) ++xy_tif; else xy_tif=argv[0];

	if ((xy_tif[1]!='x' && xy_tif[1]!='X') ||
	    (xy_tif[2]!='y' && xy_tif[2]!='Y') || xy_tif[3]!='_' ||
	    (xy_tif[4]!='t' && xy_tif[4]!='T') ||
	    (xy_tif[5]!='i' && xy_tif[5]!='I') ||
	    (xy_tif[6]!='f' && xy_tif[6]!='F')) {
	    (void)fputs(xy_tif,stderr); Error(" : unknown command.");
	}
	(void)strncpy(xy,xy_tif,(size_t)3); xy[3]='\0';

	if (argc!=3 && argc!=5 && argc!=7) {
	    (void)fprintf(stderr,
			  "usage : %s directory angle {{base step} BPS %s.tif}",
			  xy_tif,xy); Error("");
	}
	SearchRawFiles(argv[1],&O,&D,&N,&Q);

	(void)sprintf(path,"%s/%s",argv[1],O);
	if ((file=fopen(path,"r"))==NULL) {
	    (void)fputs(path,stderr); Error(" : file not found.");
	}
	angle=atof(argv[2]);

	while (fgets(line,STR_LEN,file)!=NULL)
	    if (sscanf(line,"%d %lf %s %d",&n,&t,A,&i_e)==4 &&
		n>=0 && n<N && i_e>=0 && i_e<=1 && Q[n]!=NULL)
		if (i_e==0) {
		    if ((*ptr=list=(List *)malloc(sizeof(List)))==NULL)
			Error("no memory for log data list.");

		    list->n=n; list->t=t; ptr=(&(list->next));
		}
		else if (sscanf(A,"%lf",&a)==1) {
		    dat=Abs(a-angle);
		    if (e==(-1) || dat<Dat) {
			e=n; te=t; (void)strcpy(Ae,A); Dat=dat;
		    }
		}

	if (top==NULL || e==(-1)) Error("no I0- and/or I-image file.");

	(void)fclose(file);

	*ptr=NULL; i=top->n; Dat=Abs(top->t-te);
	for (list=top->next; list!=NULL; list=list->next)
	    if ((dat=Abs(list->t-te))<Dat) {
		i=list->n; Dat=dat;
	    }

	(void)fprintf(stderr,"d.img = %s/%s\n"
			     "i.img = %s/%s\n"
			     "t.img = %s/%s at angle = %s\n",
			     argv[1],D,argv[1],Q[i],argv[1],Q[e],Ae);

	if (argc==3)
	    n=0;
	else {
	    (void)sprintf(hp3xy,"hp3%s %s/%s %s/%s %s/%s",
				xy,argv[1],D,argv[1],Q[i],argv[1],Q[e]);

	    for (n=3; n<argc; n++) (void)strcat(strcat(hp3xy," "),argv[n]);

	    n=system(hp3xy);
	}
	return n;
}
